/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.algebra;

import java.util.Collections;
import java.util.List;
import java.util.Set;

public abstract class BinaryAlgebra extends BinaryOperator implements Relation
{
    private static final String RCSRevision = "$Revision: 1.6 $";
    private static final String RCSName     = "$Name: XQ1_1_1 $";

    List _keys;
    Set _providedTableInstance = Collections.singleton(this);

    public BinaryAlgebra(Expression leftOperand, Expression rightOperand)
    {
        super (leftOperand,rightOperand);
    }

    public Set providedTableInstances() {
        return _providedTableInstance;
    };

	public AttributeExpression findNonNullAttribute() {
		AttributeExpression ret = ((Relation)_leftOperand).findNonNullAttribute();
		if (ret == null)
			ret = ((Relation)_rightOperand).findNonNullAttribute();	// QUESTION: is it necessary. Relation should not be identical ?
		return ret;
	}

    public List getItems() { return null;}

    public List getKeys()
    {
        return _keys;
    }

    public List nameTest(String name)
    {
        return ((Relation)getLeftOperand()).nameTest(name);
    }


    public boolean replaceChild(Expression oldChild, Expression newChild)
    {
        /* implementation for Merge, Union, Intersect and Difference, but not for OuterJoin */
        boolean retVal = false;
        if (getLeftOperand() == oldChild) {
            setLeftOperand(newChild);
            retVal = true;
        }
        else if (getRightOperand()== oldChild) {
            setRightOperand(newChild);
            retVal = true;
        }

        return retVal;
    }
}
