/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.algebra;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.extractor.sql.SqlExpression;

/**
 * NOTE: This class may have been used when front-end used to pass lists of literals.
 * May be removed ?
 */
public final class ConstantTempTable extends Table
{

    private static final String RCSRevision = "$Revision: 1.4 $";
    private static final String RCSName     = "$Name: XQ1_1_1 $";


	protected List      _tuples;


    public ConstantTempTable(org.xquark.extractor.metadata.Table mTable) {
		super(mTable);
    }


    synchronized Object clone(Map clonedExprs)  throws CloneNotSupportedException   {
        //Trace.enter(this, "clone(Map clonedExprs)");

        ConstantTempTable retVal = (ConstantTempTable)super.clone(clonedExprs);

        clonedExprs.put(this, retVal);
        //Trace.exit(this, "clone(Map clonedExprs)");
        return retVal;
    }


	public void addValues(List values) {
		if (null == _tuples ) {
			_tuples = new ArrayList();
		}
		_tuples.add(values);
	}

	public List getValues() {
		return _tuples;
	}

    public SqlExpression accept (GenSqlVisitor visitor) throws SqlWrapperException {
        return visitor.visit(this);
    }

    public void accept (AlgebraVisitor visitor) throws SqlWrapperException {
        visitor.visit(this);
    }

}
