/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.algebra;

import java.util.Collections;
import java.util.List;
import java.util.Set;

import org.xquark.extractor.common.SqlWrapperException;
import org.xquark.extractor.sql.SqlExpression;

public final class DummyTable extends Expression implements Relation {


    private static final String RCSRevision = "$Revision: 1.5 $";
    private static final String RCSName     = "$Name: XQ1_1_1 $";


    Set _providedTableInstances = null;
    
    public DummyTable() {}

    public Set providedTableInstances() {
        if (null == _providedTableInstances)
            _providedTableInstances = Collections.singleton(this);
        return _providedTableInstances;
    }


    public Set visibleTableInstances() {
         return null;
    }

	public AttributeExpression findNonNullAttribute() {
		return null;
	}
	
    public List getItems() {
        return null;
    }

    public List getKeys() {
        return null;
    };

    public List nameTest(String name){
        return null;
    }

    public List getOperands()
    {
        return null;
    }

    public String pprint  ( )
    {
        return  "DummyTable";
    }

    public SqlExpression accept (GenSqlVisitor visitor) throws SqlWrapperException
    {
        return visitor.visit(this);
    }

    public void accept (AlgebraVisitor visitor) throws SqlWrapperException
    {
        visitor.visit(this);
    }

	/**
	 * The semantics chosen for equals of algebra nodes is "the same algebra operator
	 * hierarchy referring to the same database objects".
	 * @param o the expression to be compared with this.
	 */
	public boolean deepEquals(Object o)
	{
		return false;
	}
}
