/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.algebra;

import java.util.ArrayList;
import java.util.List;

import org.xquark.extractor.common.Debug;
import org.xquark.extractor.common.SqlWrapperException;

/**
 * Grabs top-level (blocks on 1st project encoutered) in a list.
 * UNUSED
 */
public final class TopLevelProjectsVisitor extends DefaultAlgebraVisitor {
	private static final String RCSRevision = "$Revision: 1.8 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";

	private List _topLevelProjectList = new ArrayList();

	public  TopLevelProjectsVisitor() {
	}

	public void reinit() {
		_topLevelProjectList.clear();
	}

	public List getProjectList(){
		Debug.assertTrue(!_topLevelProjectList.isEmpty(),"!_topLevelProjectList.isEmpty()");
		return _topLevelProjectList;
	}

	public void visit(Expression arg) throws SqlWrapperException {
		Debug.assertTrue(false, "NYI for " + arg.pprint());
	}

	public void visit(BinaryAlgebra arg) throws SqlWrapperException {
		arg.getLeftOperand().accept(this);
		arg.getRightOperand().accept(this);
	}

	public void visit(Join arg) throws SqlWrapperException {
		List list = arg.getOperands();
		Debug.assertTrue(null!=list,"null!=list");

		Expression expr = null ;
		for (int i = 0; i < list.size(); i++) {
			expr = (Expression)list.get(i);
			expr.accept(this);
		}
	}

	public void visit(UnaryAlgebra arg) throws SqlWrapperException {
		Expression operand = arg.getOperand();
		operand.accept(this);
	}

	public void visit(UnOpProject arg) throws SqlWrapperException {
		_topLevelProjectList.add(arg);
	}
}
