/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.common;

/**
 * Extractor constants definition (mainly configuration parameters
 */
public interface Constants {

    /* configuration file tokens. See org.xquark.extractor.ExtractorConfigurationFileHandler */
    public String LABEL_DATASOURCE = "datasource";
    public String LABEL_SPEC_DATABASE_NAME = "database_name";
    public String LABEL_SPEC_DATABASE_VERSION = "database_version";
    public String LABEL_SPEC_DESCRIPTION = "description";
    public String LABEL_SPEC_CASE = "case";
    public String LABEL_SPEC_USER = "user";
    public String LABEL_SPEC_PASSWORD = "password";
    public String LABEL_SPEC_URL = "url";
	public String LABEL_SPEC_JNDI = "jndi";
    public String LABEL_SPEC_SUBST = "substitutions";
    public String LABEL_SPEC_SEL = "selections";
    public String LABEL_SPEC_SUBST_CHAR = "character";
    public String LABEL_SPEC_SUBST_VALUE = "value";
    public String LABEL_SPEC_SUBST_SUBST = "subst";
    public String LABEL_SPEC_SUBST_NAMECASE = "nameCase";
    public String LABEL_SPEC_DRIVER = "driver";
    public String LABEL_SPEC_INCLUDES = "includes";
    public String LABEL_SPEC_EXCLUDES = "excludes";
    public String LABEL_SPEC_SITE = "site";
    public String LABEL_SPEC_CATALOG = "catalog";
    public String LABEL_SPEC_SCHEMA = "schema";
    public String LABEL_SPEC_TABLE = "table";
    public String LABEL_SPEC_COLUMN = "column";
    public String LABEL_SPEC_PK_COLUMN = "pk_column";
    public String LABEL_SPEC_NAME = "name";
    public String LABEL_SPEC_ALIAS = "alias";
    public String LABEL_SPEC_REGEX = "regex";
    public String LABEL_SPEC_TARGETNAMESPACE = "targetNamespace";
    public String LABEL_SPEC_ELEMENTFORMDEFAULT = "elementFormDefault";
    public String LABEL_SPEC_IMPORT_SCHEMA = "importschema";
    public String LABEL_SPEC_IMPORT_MODULE = "importmodule";
    public String LABEL_SPEC_SCHEMAS = "schemas";
    public String LABEL_SPEC_MODULES = "modules";
    public String LABEL_SPEC_FILENAME = "filename";
    public String LABEL_SPEC_QUALIFIED = "qualified";


    /* QNameEncoding constants */
	public int CASE_MIXED = 0;
	public int CASE_UPPER = 1;
	public int CASE_LOWER = 2;

	public String CASE_MIXED_TOKEN = "mixed";
	public String CASE_UPPER_TOKEN = "upper";
	public String CASE_LOWER_TOKEN = "lower";
	
	/* Selection types */
	public final static byte NONE = 0;
	public final static byte INCLUDES = 1;
	public final static byte EXCLUDES = 2;
	public final static int UNQUALIFIED = 0;
	public final static int QUALIFIED = 1;

	public final static String[] ELEMENT_FORM_DEFAULT =
		{ "unqualified", "qualified" };

}
