/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.metadata;

/**
 * Metadata node corresponding to a physical connection and a configuration
 * file.
 */
public class Site extends NamedNode {
    private static final String RCSRevision = "$Revision: 1.4 $";
    private static final String RCSName = "$Name: XQ1_1_1 $";

    public Site() {}

    /**
     * @param name
     */
    public Site(String name) {
        super(name);
    }

    public String pprint() {
        StringBuffer retVal = new StringBuffer();

        String newLine = System.getProperty("line.separator");

        retVal.append("MWMWMWMWMW Site : ");
        retVal.append(_name);
        retVal.append(" MWMWMWMWMW");
        retVal.append(newLine);

        for (int i = 0; i < _children.size(); i++) {
            retVal.append(((NamedNode) _children.get(i)).pprint());
            retVal.append(newLine);
        }
        return retVal.toString();
    }
}
