/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Odonata.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sql;

import org.xquark.jdbc.typing.MappingInfo;
import org.xquark.schema.SimpleType;

/**
 * Data structure containing JDBC prepared statement parameter info. 
 */
public class PlaceHolderInfo {
    public String varId = null;
    public StatementInfo stmtInfo = null;
    public int index = 0; // JDBC numbering : starting at 1
    public MappingInfo mappingInfo = null;
    
    public PlaceHolderInfo(StatementInfo stmtInfo, int index, String varId, SimpleType sType) {
        this.stmtInfo = stmtInfo;
        this.index = index;
        this.varId = varId;
        if (sType != null)
            mappingInfo = new MappingInfo(sType);
    }
}
