/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sql;


public class SqlBinOpBoolean extends SqlBinaryOperator
{

	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";

    private int _operator;

    public SqlBinOpBoolean(int operator, SqlExpression leftOperand, SqlExpression rightOperand)
    {
        super (  leftOperand,  rightOperand );
        setOperator ( operator ) ;
    }

    /**
    @roseuid 3BD177D20177
     */
    public SqlBinOpBoolean()
    {

    }

    /**
    Access method for the _operator property.
    @return   the current value of the _operator property
    @roseuid 3BD177D20344
     */
    public int getOperator()
    {
        return _operator;
    }

    /**
    Sets the value of the _operator property.
    @param aOperator the new value of the _operator property
    @roseuid 3BD177D20376
     */
    public void setOperator(int aOperator)
    {
        _operator = aOperator;
    }

    /**
    @return String
    @roseuid 3BD177D3001A
     */
    public String toSql(Context context)
    {
        //Trace.enter(this,"toSql(Context context)");
        StringBuffer retVal = new StringBuffer();

        retVal.append("(");
        retVal.append(getLeftOperand().toSql(context));
        retVal.append(") ");

        retVal.append(BOOLEAN_OPERATORS [_operator]);

        retVal.append(" (");
        retVal.append(getRightOperand().toSql(context));
        retVal.append(")");

        //Trace.exit(this,"toSql(Context context)", retVal);
        return retVal.toString();
    }
}
