/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sql;


public abstract class SqlBinaryOperator extends SqlExpression
{

	private static final String RCSRevision = "$Revision: 1.4 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";

    protected SqlExpression _leftOperand;
    protected SqlExpression _rightOperand;

    /**
    @param leftOperand
    @param rightOperand
    @roseuid 3BD177CF0295
     */
    public SqlBinaryOperator(SqlExpression leftOperand, SqlExpression rightOperand)
    {
        setLeftOperand( leftOperand) ;
        setRightOperand( rightOperand) ;
    }

    /**
    @param leftOperator
    @param rightOperator
    @roseuid 3BD177CF0263
     */
    public SqlBinaryOperator()
    {

    }

    /**
    Access method for the _leftOperand property.

    @return   the current value of the _leftOperand property
     */
    public SqlExpression getLeftOperand()
    {
     return _leftOperand;
    }

    /**
    Sets the value of the _leftOperand property.

    @param aLeftOperand the new value of the _leftOperand property
     */
    public void setLeftOperand(SqlExpression aLeftOperand)
    {
        _leftOperand = aLeftOperand;
    }

    /**
    Access method for the _rightOperand property.

    @return   the current value of the _rightOperand property
     */
    public SqlExpression getRightOperand()
    {
     return _rightOperand;
    }

    /**
    Sets the value of the _rightOperand property.

    @param aRightOperand the new value of the _rightOperand property
     */
    public void setRightOperand(SqlExpression aRightOperand)
    {
        _rightOperand = aRightOperand;
    }

}
