/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sql;

import org.xquark.jdbc.typing.DbType;

abstract public class SqlConvert extends SqlExpression {

	private static final String RCSRevision = "$Revision: 1.6 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";


    protected SqlExpression _expression;
    protected DbType _originalType;
    protected DbType _targetType;

    public SqlConvert() {
    }

    public SqlConvert(SqlExpression expr, DbType originalType, DbType targetType) {
        setExpression(expr);
        setOriginalType(originalType);
        setTargetType(targetType);
    }

    public DbType getOriginalType() {
        return _originalType;
    }

    public void setOriginalType(DbType originalType) {
        _originalType = originalType;
    }

    public DbType getTargetType() {
        return _targetType;
    }

    public void setTargetType(DbType targetType) {
        _targetType = targetType;
    }

    public SqlExpression getExpression() {
        return _expression;
    }

    public void setExpression(SqlExpression expression) {
        _expression = expression;
    }

    abstract public String toSql (Context context);
}
