/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sql;


public class SqlIfThenElse extends SqlExpression {

	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";


    protected SqlExpression _if;
    protected SqlExpression _then;
    protected SqlExpression _else;

    /**
     * @roseuid 3B273D2502F9
     */
    public SqlIfThenElse()
    {

    }

    /**
     * @param iif
     * @param tthen
     * @param eelse
     * @roseuid 3AB871F30183
     */
    public SqlIfThenElse(SqlExpression iif, SqlExpression tthen, SqlExpression eelse)
    {
        setIf(iif);
        setThen(tthen);
        setElse(eelse);
    }


    public SqlExpression getIf()
    {
     return _if;
    }

    public void setIf(SqlExpression iif)
    {
        _if = iif;
    }

    public SqlExpression getThen()
    {
     return _then;
    }

    public void setThen(SqlExpression tthen)
    {
        _then = tthen;
    }

    public SqlExpression getElse()
    {
     return _else;
    }

    public void setElse(SqlExpression eelse)
    {
        _else = eelse;
    }

    public String toSql (Context context)
    {
        //Trace.enter(this,"toSql(Context context)");

        StringBuffer retVal = new StringBuffer();
        retVal.append("( SELECT ");
        retVal.append(_then.toSql(context));
        retVal.append(" FROM DUAL WHERE ");
        retVal.append(_if.toSql(context));

        retVal.append(" UNION ALL SELECT  ");
        retVal.append(_else.toSql(context));
        retVal.append(" FROM DUAL WHERE NOT (");
        retVal.append(_if.toSql(context));
        retVal.append(") )");

        //Trace.exit(this,"toSql(Context context)");
        return retVal.toString();
    }
}
