/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sql;


public class SqlUnOpExists extends SqlUnaryOperator
{

	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";

    private boolean _notExists;

    /**
    @param query
    @param notExists
    @roseuid 3BD1780501E9
     */
    public SqlUnOpExists(SqlExpression query, boolean notExists)
    {
        super ( query ) ;
        setNot ( notExists ) ;
    }

    /**
    @param query
    @roseuid 3BD17805012A
     */
    public SqlUnOpExists(SqlExpression query)
    {
        super ( query ) ;
        setNot ( false )  ;
    }

    /**
    @roseuid 3BD1780500F8
     */
    public SqlUnOpExists()
    {

    }

    /**
    @param notExists
    @roseuid 3BD178050301
     */
    public void setNot(boolean notExists)
    {
        _notExists = notExists ;
    }

    /**
    @return boolean
    @roseuid 3BD178050397
     */
    public boolean getNot()
    {
        return _notExists ;
    }

    /**
    @return String
    @roseuid 3BD1780503D3
     */
    public String toSql(Context context)
    {
        //Trace.enter(this,"toSql(Context context)");

        StringBuffer   retVal = new StringBuffer();
        if ( _notExists )
        {
            retVal.append("NOT EXISTS ( ");
        }
        else
        {
            retVal.append("EXISTS ( ");
        }

        retVal.append(getOperand().toSql(context));
        retVal.append(" )");

        //Trace.exit(this,"toSql(Context context)");
        return retVal.toString();
    }
}
