/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Odonata.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sql;

import java.util.ArrayList;
import java.util.List;

/**
 * Data structure containing an SQL statement as a string and a JDBC object. 
 */
public class StatementInfo {
    public String sStmt = null;
    public List parameterList = new ArrayList(); // map between parameter name and a list of PlaceHolderInfo
    
    public StatementInfo() {}
    
    public StatementInfo(String stringStmt) {
        sStmt = stringStmt;
    }
    
    public void registerParameter(SqlPlaceHolder placeHolder, int index) {
        parameterList.add(
			                new PlaceHolderInfo(this,
				                index,
				                placeHolder.getExternalVariable().getExpandedName(),
				                placeHolder.getExternalVariable().getSimpleType()
				                )
			                );
    }
}
