/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sybase.sql;


import org.xquark.extractor.sql.Context;
import org.xquark.extractor.sql.SqlExpression;

public class SfSubString  extends org.xquark.extractor.sql.SfSubString
{

	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";


    public SfSubString()
    {
        super();
    }

    public SfSubString(SqlExpression arg0, SqlExpression arg1)
    {
        super(arg0, arg1);
    }

    public SfSubString(SqlExpression arg0, SqlExpression arg1, SqlExpression arg2)
    {
        super(arg0, arg1, arg2);
    }

    public String toSql (Context context)
    {
        //Trace.enter(this,"toSql");


        StringBuffer retVal = new StringBuffer();
		String arg0 = null;
		String arg1 = null;
		String arg2 = null;

        retVal.append("SUBSTRING(");
		arg0 = getArgument(0).toSql(context);
        retVal.append(arg0);
        int num = getArgumentNumber();

		arg1 = getArgument(1).toSql(context);
        retVal.append(",");
        retVal.append(arg1);

        if ( 2 < num){
            retVal.append(",");
			arg2 = getArgument(2).toSql(context);
            retVal.append(arg2);
        }
		else {
			retVal.append(",");
			retVal.append("CHAR_LENGTH(");
			retVal.append(arg0);
			retVal.append(")");
			/* the following is not neccessary
			retVal.append("-");
			retVal.append(arg1);
			retVal.append("+1");
			*/
		}
        retVal.append(")");

        //Trace.exit(this,"toSql");
        return retVal.toString();
    }
}
