/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.extractor.sybase.sql;

import org.xquark.extractor.sql.Context;
import org.xquark.extractor.sql.SqlExpression;

public class SqlInsert extends org.xquark.extractor.sql.SqlExpression {
	private static final String RCSRevision = "$Revision: 1.5 $";
	private static final String RCSName = "$Name: XQ1_1_1 $";


	private org.xquark.extractor.sql.SqlTable _tableName;
	protected SqlExpression _values;

	public SqlInsert() {
		super();
	}

	public SqlInsert(org.xquark.extractor.sql.SqlTable tableName, SqlExpression values) {
		super();
		setTableName(tableName);
		setValues(values);
	}

	public org.xquark.extractor.sql.SqlTable getTableName() {
		return _tableName;
	}

	public void setTableName(org.xquark.extractor.sql.SqlTable tableName) {
		_tableName = tableName;
	}

	public SqlExpression getValues() {
		return _values;
	}

	public void setValues(SqlExpression values) {
		_values = values;
	}

    public String toSql(Context context) {
        //Trace.enter(this,"toSql(Context context)");
        StringBuffer retVal = new StringBuffer();

		retVal.append("INSERT INTO ");
		retVal.append(getTableName().toSql(context));

//		Debug.assertTrue(getValues() instanceof SqlValueList || getValues().toSql(context),
//					"getValues() instanceof SqlValueList || getValues().toSql(context)");

		retVal.append(" VALUES ");
		retVal.append(getValues().toSql(context));

        //Trace.exit(this,"toSql(Context context)", retVal);
        return retVal.toString() ;
    }
}
