/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.mapper.dbms;

/**
 * This object perform simple SQL statement customization.
 *
 */
public class SQLStatementCustomizer
{
	private static final String RCSRevision = "$Revision: 1.2 $";
	private static final String RCSName = "$Name: XQ1_1_1 $";

	private String preparedStatement = null;

	/**
	 * Constructor for SQLStatementCustomizer.
	 */
	public SQLStatementCustomizer(String statement)
	{
		preparedStatement = statement;
	}

	public String getTableCreationStatement(
		String tableName,
		String columnSpecs)
	{
		StringBuffer sb = new StringBuffer();
		int offset = preparedStatement.indexOf('?');
		sb.append(preparedStatement.substring(0, offset));
		sb.append(tableName);
		int offset2 = preparedStatement.indexOf('?', offset + 1);
		sb.append(preparedStatement.substring(offset + 1, offset2));
		sb.append(columnSpecs);
		sb.append(preparedStatement.substring(offset2 + 1));
		return sb.toString();
	}

	public String getSelectStatement(
		String columnList,
		String tableName,
		String filterClause)
	{
		StringBuffer sb = new StringBuffer();
		int offset = preparedStatement.indexOf('?');
		sb.append(preparedStatement.substring(0, offset));
		sb.append(columnList);
		int offset2 = preparedStatement.indexOf('?', offset + 1);
		sb.append(preparedStatement.substring(offset + 1, offset2));
		sb.append(tableName);
		offset = offset2 + 1;
		offset2 = preparedStatement.indexOf('?', offset);
		sb.append(preparedStatement.substring(offset, offset2));
		sb.append(filterClause);
		sb.append(preparedStatement.substring(offset2 + 1));
		return sb.toString();
	}
}
