/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.mapper.mapping;

/**
 * Constants for mapping feature. Mainly defining tokens for the mapping language.
 *
 */
public interface MappingConstants {

  public static final String MAPPING_URI = 
    "http://www.xquark.org/Repository/1.0/Mapping";
  public static final String BRIDGE_MAPPING_URI = 
    "http://www.xquark.org/Bridge/1.1/Mapping";
  public static final String BRIDGE_MAPPING_URI_1_0 = 
    "http://www.xquark.org/Bridge/1.0/Mapping";
  
  // Mapping tags
  public static final String MAPPING_TAG = "mapping";
  public static final String MAP_TAG = "map";
  public static final String ELEMENT_TAG = "element";
  public static final String ATTRIBUTE_TAG = "attribute";
  public static final String GENERATOR_TAG = "generator";
  
  // mapping attributes
  public static final String VERSION_ATTR = "version";
  public static final String TABLE_ATTR = "table";
  public static final String TYPE_ATTR = "type";
  public static final String NAME_ATTR = "name" ;
  public static final String ACTION_ATTR = "action";
  public static final String COLUMN_ATTR = "column";
  public static final String REF_ATTR = "ref";
  public static final String MAP_ATTR = "map";
  public static final String UPDATE_WHEN_MISSING_ATTR = "updateColumnWhenMissing";
  public static final String IN_SELECT_ATTR = "inSelect";
  public static final String IN_KEY_ATTR = "inKey";
  public static final String BATCH_SIZE_ATTR = "batchSize";
  public static final String VAR_ATTR = "variable";
  public static final String METHOD_ATTR = "method";	// NOTE: deprecated
  public static final String USER_GENERATOR_ATTR = "class";
  public static final String XPATH_ATTR = "xpath";	// NOTE: not yet implemented
  public static final String SCHEMA_LOCATION_ATTR = "schemaLocation";
  public static final String NO_NS_SCHEMA_LOCATION_ATTR = "noNamespaceSchemaLocation";

  // Values
  
  public static final String TRUE_VALUE = "true";
  public static final String FALSE_VALUE = "false";
  
  public static final String TRUE_NUM_VALUE = "1";
  public static final String FALSE_NUM_VALUE = "0";

  public static final String INSERT_VALUE = "insert";
  public static final String CHECK_VALUE = "check";
  public static final String SELECT_VALUE = "select";
  public static final String UPDATE_VALUE = "update";
  
  public static final String DOCID_VALUE = "$DocumentID";
  public static final String DOCOID_VALUE = "$DocumentOID";
  public static final String BUCKET_VALUE = "$BucketOID";
  public static final String UOID_VALUE = "$UOID";
  public static final String PATHID_VALUE = "$PathOID";
  public static final String TAG_VALUE = "$QName";
  public static final String URI_VALUE = "$NamespaceURI$";
  public static final String LOCAL_VALUE = "$LocalName";
  public static final String RANK_VALUE = "$NodeRank";
  public static final String VALUE_VALUE = "$NodeValue";

  /* System generator codes */
  public static final short DOCID_CODE = 1;
  public static final short DOCOID_CODE = 10;
  public static final short BUCKET_CODE = 2;
  public static final short UOID_CODE = 3;
  public static final short PATHID_CODE = 4;
  public static final short TAG_CODE = 5;
  public static final short URI_CODE = 6;
  public static final short LOCAL_CODE = 7;
  public static final short RANK_CODE = 8;
  public static final short VALUE_CODE = 9;
  
  public static final int INSERT = 1;
  public static final int CHECK = 2;
  public static final int UPDATE = 3;
  public static final int SELECT = 4;

  public static final int NO_ROLE = 0;
  public static final int KEY_ROLE = 1;
  public static final int SELECT_ROLE = 2;
}
