/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.mapper.storage;

import java.sql.SQLException;

import org.xquark.mapper.dbms.TableInfo;
import org.xquark.mapper.metadata.ExtraNode;

/**
 * Object used to perform XML structure node storage.
 *
 */
public abstract class ExtraDataPersistentNode extends AbstractPersistentNode
{
    private static final String RCSRevision = "$Revision: 1.2 $";
    private static final String RCSName     = "$Name: XQ1_1_1 $";
    
    protected ExtraNode node = new ExtraNode();
    
    public ExtraDataPersistentNode(TableInfo tableInfo)
    {
        super(tableInfo);
    }
    
    public short getType()
    { return node.type;}
    public short getPath()
    { return node.path;}
    public short getPosition()
    { return node.position;}
    public int getOffset()
    { return node.offset;}
    public String getData()
    { return node.data;}
    public short getRowNum()
    { return node.rowNum;}
    public boolean isNil()
    { return node.isNil();}
    
    public ExtraNode copyNode()
    {
        return (ExtraNode)node.clone();
    }
    
    public void reset() throws SQLException
    {
        super.reset();
        node.clear();
    }
    
    /**
     * redefinition of getUOID
     */
    public long getAnchor()
    { return getUOID();}
    
}
