/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.mapper.storage;

import org.xquark.mapper.RepositoryException;
import org.xquark.mapper.metadata.StoragePathMetadata;
import org.xquark.xpath.PathExpr;



/** This interface is used by Filers of Repository &amp; mapper.
 */
public interface PathIterator
{
 

    
    public void reset();
    
    /* Create a node if it does not exist without entering it */
    public StoragePathMetadata createNode(String namespace, String localName, byte type)
    throws RepositoryException;

    /* Enter the specified node element or create it if does not exist */
    public StoragePathMetadata push(String namespace, String localName)
    throws RepositoryException;

    public StoragePathMetadata pop();
    
    /** Return the absolute position of the locator.
     * <p>i.e., !isDiscardable()</p>
     */
    public PathExpr getLocation();
    
    public StoragePathMetadata getStoragePathMetadata();
}
