/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

/*
 * _StorageContext.java
 *
 * Created on 20 septembre 2002, 10:47
 */

package org.xquark.mapper.storage;

import org.xquark.mapping.StorageContext;

/**
 * Internal version of the StorageContext interface.
 */
public interface _StorageContext extends StorageContext
{
	/**
	 * Returns the "canonical" form of the node data. This form is the result
	 * of the tranformation by the XML Schema API of the node data into the
	 * value space (actual value) and a "reverse" conversion to the canonical
	 * lexical form. Repository is expected to stored according to the target
	 * type, the actual value or, if not possible, the canonical form.
	 * @return The canonical form of the current node data.
	 */
    public String getCanonicalString();
}
