/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.mapper.util;


import java.util.*;

public class BaseTypedList implements Cloneable
{
private static final String RCSRevision = "$Revision: 1.2 $"; 
private static final String RCSName     = "$Name: XQ1_1_1 $";
    public List list;
    
    public BaseTypedList()
    {
        this.list = new ArrayList();
    }
    
    public BaseTypedList(int size)
    {
        this.list = new ArrayList(size);
    }
    
    public BaseTypedList(List list)
    {
        this.list = list;
    }
    
    public int size()
    {
        if(list==null)
            return 0;
        return list.size();
    }
    
    public void add(Object obj)
    {
        list.add(obj);
    }
    
    public void add(int i, Object obj)
    {
        list.add(i, obj);
    }
    
    public void clear()
    {
        list.clear();
    }
    
    public void remove(int index)
    {
        list.remove(index);
    }
    
    public void remove(Object element)
    {
        list.remove(element);
    }
    
    public void removeLast()
    {
        list.remove(list.size() - 1);
    }
    
    public List getList()
    {
        return list;
    }
    
    public void set(int index, Object element)
    {
        list.set(index, element);
    }
    
    
    public BaseTypedList subList(int begin, int end)
    {
        return new BaseTypedList(list.subList(begin, end));
    }
    
    public ListIterator listIterator()
    {
        return list.listIterator();
    }
    
    public Iterator iterator()
    {
        return list.iterator();
    }
    
    public int hashCode()
    {
        return list.hashCode();
    }
    
    public boolean equals(Object o)
    {
        if (( o != null) && (o instanceof BaseTypedList))
            return this.list.equals(((BaseTypedList)o).list);
        else
            return false;
    }
    
    public String toString()
    {
        return list.toString();
    }
    
    public Object clone()
    {
        BaseTypedList o = null;
        try {
            o = (BaseTypedList)super.clone();
            o.list = (List)((ArrayList)o.list).clone();
        }
        catch (CloneNotSupportedException e) {
            throw new RuntimeException("The List supplied to build the typed list is not clonable");
        }
        return o;
    }
}
