/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

/*
 * RuntimeRepositoryException.java
 *
 * Created on 2 septembre 2002, 11:05
 */

package org.xquark.mapper.util;

import org.xquark.mapper.RepositoryException;

/**
 *  Created to raise exceptions even if the interface does not assumes it.
 *
 */
public class RepositoryRuntimeException extends RuntimeException
{
	private static final String RCSRevision = "$Revision: 1.2 $";
	private static final String RCSName = "$Name: XQ1_1_1 $";

    RepositoryException e;
    
    /** Creates a new instance of RepositoryRuntimeException */
    public RepositoryRuntimeException(RepositoryException e)
    {
        this.e = e;
    }
    
    public RepositoryException getRepositoryException()
    {
        return e;
    }
}
