/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.mapper.util;


import java.util.ArrayList;
import java.util.StringTokenizer;


/**
 * StringList.
 */
public class StringList extends BaseTypedList
{
private static final String RCSRevision = "$Revision: 1.2 $"; 
private static final String RCSName     = "$Name: XQ1_1_1 $";
    public StringList() {}
    
    public StringList(int capacity)
    {
        super(capacity);
    }
    
    public StringList(String s)
    {
        StringTokenizer tokens = new StringTokenizer(s, ".");
        while(tokens.hasMoreTokens())
        {
            list.add(tokens.nextToken());
        }
    }
    
    public StringList(ArrayList list)
    {
        super(list);
    }
    
    public String get(int i)
    {
        return (String) list.get(i);
    }
    
    public void add(String s)
    {
        list.add(s);
    }
    
    public void add(int i, String s)
    {
        list.add(i, s);
    }
    
    public int indexOf(String s)
    {
        for(int i=0; i<size(); i++)
        {
            if(get(i).equalsIgnoreCase(s))
                return i;
        }
        return -1;
    }
    
    public StringBuffer dummy()
    {
        StringBuffer dummy = new StringBuffer();
        
        for(int i=0; i<size(); i++)
        {
            dummy.append(get(i)+".");
        }
        return dummy;
    }
}
