/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.schema;

public final class ContentModel implements SchemaConstants, SchemaVisitable {
private static final String RCSRevision = "$Revision: 1.2 $"; 
private static final String RCSName     = "$Name: XQ1_1_1 $";
  
  private Object model = null;
  private int contentType;

  public ContentModel() {
    contentType = EMPTY;
    model = null;
  }

  public ContentModel(int type) {
    contentType = type;
    model = null;
  }

  public ContentModel(SimpleType model) {
    contentType = TEXT_ONLY;
    setModel(model);
  }
  
  public ContentModel(Particle model) {
    this(model, ELEMENT_ONLY);
  }
  
  public ContentModel(Particle model, int contentType) {
    this.contentType = contentType;
    setModel(model);
  }

  public void accept(SchemaVisitor visitor) throws SchemaException {
    visitor.visit(this);
  }

  public int getContentType() {
    return contentType;
  }
  
  public void setContentType(int contentType) {
    this.contentType = contentType;
  }

  public Object getModel() {
    return model;
  }

  public void setModel(Object model) {
    this.model = model;
  }

  void initModel(Object model) {
    this.model = model;
		/*
    Particle particle;
    switch (contentType) {
    case TEXT_ONLY:
      this.model = model;
      break;
    case ELEMENT_ONLY:
      SequenceModelGroup seq = new SequenceModelGroup();
      seq.add(model);
      particle = new Particle(seq);
      particle.setMinOccurs(1);
      particle.setMaxOccurs(1);
      this.model = particle;
      break;
    case MIXED:
      ChoiceModelGroup choice = new ChoiceModelGroup();
      choice.add(model);
      particle = new Particle(choice);
      particle.setMinOccurs(0);
      particle.setMaxOccursUnbounded();
      this.model = particle;
      break;
    }
		 */
  }
  
}
