/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.schema;

import org.xquark.schema.loader.*;

public class DefaultSchemaVisitor implements SchemaVisitor {
private static final String RCSRevision = "$Revision: 1.2 $"; 
private static final String RCSName     = "$Name: XQ1_1_1 $";

  public void visit(Schema schema) throws SchemaException {
  } 
  
  public void visit(SchemaComponent comp) throws SchemaException {
  }
  
  public void visit(SchemaComponentRef ref) throws SchemaException {
    visit((SchemaComponent)ref);
  }

  public void visit(Type type) throws SchemaException {
    visit((SchemaComponent)type);
  }

  public void visit(SimpleType type) throws SchemaException {
    visit((Type)type);
  }
  
  public void visit(ComplexType type) throws SchemaException {
    visit((Type)type);
  }

  public void visit(TypeRef ref) throws SchemaException {
    visit((Type)ref);
  }

  public void visit(SimpleBaseTypeRef ref) throws SchemaException {
    visit((Type)ref);
  }

  public void visit(Declaration decl) throws SchemaException {
    visit((SchemaComponent)decl);
  }

  public void visit(ElementDeclaration decl) throws SchemaException {
    visit((Declaration)decl);
  }

  public void visit(AttributeDeclaration decl) throws SchemaException {
    visit((Declaration)decl);
  }
  
  public void visit(ElementDeclarationRef ref) throws SchemaException {
    visit((ElementDeclaration)ref);
  }
  
  public void visit(AttributeDeclarationRef ref) throws SchemaException {
    visit((AttributeDeclaration)ref);
  }
  
  public void visit(Wildcard wildcard) throws SchemaException {
    visit((SchemaComponent)wildcard);
  }
  
  public void visit(ModelGroupDefinition def) throws SchemaException {
    visit((SchemaComponent)def);
  }
    
  public void visit(AttributeGroupDefinition def) throws SchemaException {
    visit((SchemaComponent)def);
  }
  
  public void visit(ContentModel model) throws SchemaException {
  }
  
  public void visit(Particle particle) throws SchemaException {
  }
  
  public void visit(ModelGroup group) throws SchemaException {
  }
  
  public void visit(AllModelGroup group) throws SchemaException {
    visit((ModelGroup)group);
  }
  
  public void visit(ChoiceModelGroup group) throws SchemaException {
    visit((ModelGroup)group);
  }
  
  public void visit(SequenceModelGroup group) throws SchemaException {
    visit((ModelGroup)group);
  }
  
  public void visit(IdentityConstraint constraint) throws SchemaException {
    visit((SchemaComponent)constraint);
  }
  
  public void visit(NotationDeclaration notation) throws SchemaException {
    visit((SchemaComponent)notation);
  }
  
  public void visit(IdentityConstraintRef ref) throws SchemaException {
    visit((IdentityConstraint)ref);
  }
  
}
