/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

/*
 * SerializingIterationVisitor.java
 *
 * Created on 5 novembre 2001, 13:51
 */

package org.xquark.schema;


public class SerializingIterationVisitor extends IterationVisitor {
private static final String RCSRevision = "$Revision: 1.2 $"; 
private static final String RCSName     = "$Name: XQ1_1_1 $";

  SerializingIterationVisitor(SchemaVisitor pre, SchemaVisitor post) {
    super(pre, post);
  }
  
  SerializingIterationVisitor(SchemaVisitor visitor) {
    super(visitor, null);
  }
    
  public void visit(ContentModel model) throws SchemaException {
    if (pre != null) model.accept(pre);
    
    // simpleContent is alread treated in visit(ComplexType type)
    if ( model.getModel() != null && !(model.getModel() instanceof SimpleType) ) 
      ((SchemaVisitable)model.getModel()).accept(this);
    
    if (post != null) model.accept(post);
  }
}
