/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

/*
 * ValidationContextProviderImpl.java
 *
 * Created on 12 dcembre 2001, 15:23
 */

package org.xquark.schema.loader;

import org.xquark.schema.validation.ValidationContextProvider;
import org.xquark.util.NamespaceContext;

public class ContextLocatorImpl implements ValidationContextProvider, org.xml.sax.Locator {
private static final String RCSRevision = "$Revision: 1.2 $"; 
private static final String RCSName     = "$Name: XQ1_1_1 $";
    // ValidationContextProvider variables
  private org.xquark.util.NamespaceContext context;
  private String documentBase = null;
  private java.util.HashMap notationDeclarations = null;
  
  // Locator variables
  private String publicId = null;
  private String systemId = null;
  private int lineNumber = -1;
  private int columnNumber = -1;

  public ContextLocatorImpl(
                        NamespaceContext context, 
                        String documentBase,
                        org.xml.sax.Locator locator) 
  {
    this.context = context;
    this.documentBase = documentBase;
    if (locator != null) {
        this.publicId = locator.getPublicId();
        this.systemId = locator.getSystemId();
        this.lineNumber = locator.getLineNumber();
        this.columnNumber = locator.getColumnNumber();
    }
  }

  public String getNamespaceURI(String prefix) {
    return context.getNamespaceURI(prefix);
  }

  public String getPrefix(String uri) {
    return context.getPrefix(uri);
  }

  public String getDocumentBase() {
    return documentBase;
  }
  
  public java.util.Map getNotationDeclarations() {
    return notationDeclarations;
  }
  
  public void setNotationDeclarations(java.util.HashMap notations) {
    notationDeclarations = notations;
  }

    
  public java.lang.String getPublicId() {
    return this.publicId;
  }
  
  public java.lang.String getSystemId() {
    return this.systemId;
  }
  
  public int getLineNumber() {
    return this.lineNumber;
  }
  
  public int getColumnNumber() {
    return this.columnNumber;
  }
  
}  

