/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.schema.loader;

import org.xquark.schema.*;
import org.xquark.schema.validation.ValidationContextProvider;
import org.xquark.schema.validation.ValidationInfo;

public final class TypeRef extends Type {
    private static final String RCSRevision = "$Revision: 1.2 $";
    private static final String RCSName = "$Name: XQ1_1_1 $";

    public TypeRef(Schema schema, String name) {
        super(schema, name, null);
    }

    public void accept(SchemaVisitor visitor) throws SchemaException {
        visitor.visit(this);
    }

    public int getContentType() {
        return SchemaConstants.MIXED;
    }

    public SimpleType getValueType() {
        return null;
    }

    public ValidationInfo validate(String value, boolean normalize, ValidationContextProvider context)
        throws SchemaException {
        return null;
    }

    public ValidationInfo validate(StringBuffer value, boolean normalize, ValidationContextProvider context)
        throws SchemaException {
        return null;
    }

}
