/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.schema.validation;

import org.xquark.schema.SimpleType;


public class DefaultValidationInfo implements ValidationInfo {

	private StringBuffer normalizedValueBuffer;
	private String normalizedValue;
	private Object actualValue;
	private SimpleType validationType;

    public String getNormalizedValue() {
    	if (normalizedValue == null && normalizedValueBuffer != null) {
    		normalizedValue = normalizedValueBuffer.toString();
    	}
        return normalizedValue;
    }

    public Object getActualValue() {
        return actualValue;
    }

    public SimpleType getValidationType() {
        return validationType;
    }

    public void setActualValue(Object object) {
        actualValue = object;
    }

	public void clear() {
		actualValue = null;
		validationType = null;
		normalizedValue = null;
		normalizedValueBuffer = null;
	}
	
    public void setValidationType(SimpleType type) {
        validationType = type;
    }

    public void setNormalizedValueBuffer(StringBuffer buffer) {
        normalizedValueBuffer = buffer;
    }

	public void setNormalizedValue(String string) {
		normalizedValue = string;
	}

}
