/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.schema.validation;

import java.util.List;

import org.xquark.schema.Declaration;
import org.xquark.schema.SimpleType;
import org.xquark.schema.Type;

public interface PSVInfoset {
  public static String FULL = "full";
  public static String PARTIAL = "partial";
  public static String NONE = "none";
  public static String VALID = "valid";
  public static String INVALID = "invalid";
  public static String NOTKNOWN = "notKnown";
  public static String INFOSET = "infoset";
  public static String SCHEMA = "schema";

  public String getNamespaceURI();
  public String getLocalName();
  public Declaration getDeclaration();
  public Type getType();
  public String getNormalizedValue();
  public Object getActualValue();
  public List getErrorCodes();
  public String getSpecified();
  public String getSchemaDefault();
  public SimpleType getValidatingMemberType();
  public String getValidity();
  public String getValidationAttempted();
  public ElementPSVInfoset getValidationContext();
}
