/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.util;

import org.xml.sax.*;

public class DefaultXMLReader implements XMLReader {
private static final String RCSRevision = "$Revision: 1.2 $"; 
private static final String RCSName     = "$Name: XQ1_1_1 $";

  protected ContentHandler contentHandler;

  public ContentHandler getContentHandler() { 
    return contentHandler;
  }
   
  public DTDHandler getDTDHandler() {
    return null;
  }

  public EntityResolver getEntityResolver() {
    return null;
  }
  
  public ErrorHandler getErrorHandler() {
    return null; 
  }
  
  public boolean getFeature(String name) 
    throws SAXNotRecognizedException, SAXNotSupportedException 
  {
    if (name.equals("http://xml.org/sax/features/namespaces"))
      return true;
    if (name.equals("http://xml.org/sax/features/namespace-prefixes"))
      return false;
    throw new SAXNotRecognizedException("Feature: "+name);
  }
  
  public Object getProperty(String name) 
    throws SAXNotRecognizedException, SAXNotSupportedException 
  {
    throw new SAXNotRecognizedException("Property: "+name);
  }

  public void parse(InputSource input)
    throws SAXException, java.io.IOException
  {
  }
  
  public void parse(String systemId) 
    throws SAXException, java.io.IOException
  {
  }
  
  public void setContentHandler(ContentHandler handler) {
    contentHandler = handler;
  }

  public void setDTDHandler(DTDHandler handler) {}
  
  public void setEntityResolver(EntityResolver resolver) {}

  public void setErrorHandler(ErrorHandler handler) {}

  public void setFeature(String name, boolean value) 
    throws SAXNotRecognizedException, SAXNotSupportedException 
  {
    if (getFeature(name) != value)
      throw new SAXNotSupportedException("Feature: "+name);
  }
 
  public void setProperty(String name, Object value) 
    throws SAXNotRecognizedException, SAXNotSupportedException 
  {
    throw new SAXNotRecognizedException("Property: "+name);
  }

}
           

