/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.util;

/** SAX 2.0 Constants.
 *
 * @see org.xquark.repository.metadata.Dictionary
 */
public interface SAXConstants
{
 

    //
    // Constants 
    //
    public static final String SAX_NAMESPACE_FEATURE = "http://xml.org/sax/features/namespaces";
    public static final String SAX_PREFIX_FEATURE = "http://xml.org/sax/features/namespace-prefixes";
    public static final String SAX_VALIDATION_FEATURE = "http://xml.org/sax/features/validation";
    public static final String SAX_DECLARATION_PROPERTY = "http://xml.org/sax/properties/declaration-handler";
    public static final String SAX_LEXICAL_PROPERTY = "http://xml.org/sax/properties/lexical-handler";
    
    public static final String XMLNS_URI = "http://www.w3.org/2000/xmlns/";
    public static final String XMLNS_PREFIX = "xmlns";
    
    // tools features
    // if true, startDocument() & endDocument are not generated
    public static final String FRAGMENT_FEATURE = "http://wwww.xquark.org/sax/features/fragment";
    // if true, debug info is activated
    public static final String TRACE_FEATURE = "http://wwww.xquark.org/sax/features/trace";


}
