<?xml version="1.0"?>
<!--
This stylesheet contains templates for converting documentv11 to HTML.  See the
imported document2html.xsl for details.
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:import href="../../../common/xslt/html/document2html.xsl"/>

  <xsl:template match="document">
    <div class="content">
      <table summary="" class="title">
        <tr> 
          <td valign="middle"> 
            <xsl:if test="normalize-space(header/title)!=''">
              <h1>
                <xsl:value-of select="header/title"/>
              </h1>
		      <xsl:if test="normalize-space(header/subtitle)!=''">
		        <p><strong>
		          <xsl:value-of select="header/subtitle"/>
		        </strong></p>
		        <br/>
		      </xsl:if>
            </xsl:if>
          </td>
          <xsl:call-template name="printlink"/> 
          <xsl:call-template name="pdflink"/>
          <xsl:call-template name="xmllink"/>
        </tr>
      </table>
      <xsl:apply-templates select="header/type"/>
      <xsl:apply-templates select="header/notice"/>
      <xsl:apply-templates select="header/abstract"/>
      <xsl:apply-templates select="body"/>
      <div class="attribution">
        <xsl:apply-templates select="header/authors"/>
        <xsl:if test="header/authors and header/version">
          <xsl:text>; </xsl:text>
        </xsl:if>
        <xsl:apply-templates select="header/version"/>
      </div>
    </div>
  </xsl:template>

  <xsl:template match="source//br">
  		<xsl:text>&#10;</xsl:text>
  </xsl:template>
  
  <xsl:template match="table[normalize-space(caption)='_grammar']">
    <xsl:apply-templates select="@id"/>
    <table cellpadding="4" cellspacing="1" class="GrammarTable">
      <xsl:if test="@cellspacing"><xsl:attribute name="cellspacing"><xsl:value-of select="@cellspacing"/></xsl:attribute></xsl:if>
      <xsl:if test="@cellpadding"><xsl:attribute name="cellpadding"><xsl:value-of select="@cellpadding"/></xsl:attribute></xsl:if>
      <xsl:if test="@border"><xsl:attribute name="border"><xsl:value-of select="@border"/></xsl:attribute></xsl:if>
      <xsl:if test="@class"><xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute></xsl:if>
      <xsl:if test="@bgcolor"><xsl:attribute name="bgcolor"><xsl:value-of select="@bgcolor"/></xsl:attribute></xsl:if>
      <xsl:apply-templates/>
    </table>
  </xsl:template>

  <xsl:template match="table/caption[normalize-space(.)='_grammar']">
  </xsl:template>

  <xsl:template match="table[normalize-space(caption)='_grammar']/tr/td[1]">
  	<td colspan="1" rowspan="1" nowrap="nowrap">
      <xsl:apply-templates/>
  	</td>
  </xsl:template>
  
</xsl:stylesheet>
