/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.xml.xdbc;

/**
 * This interface allows the user to access query results as handles to stored
 * XML documents. This is useful for instance to rename or delete documents,
 * based on their contents. It is an error to try to use this interface when
 * the query does not return complete XML documents.
 */
public interface XMLDocumentSet extends XMLResultSet {
 

  
  /**
   * Returns the next result as an XML document and increments by 1 the cursor position.
   * The cursor is initially positioned before the first result; the first
   * call to the method nextDocument() makes the first result the current result.
   * @return the next result of the result set or null if there is no more result in the result set.
   * @throws XMLDBCException if a data source access error occurs.
   */
  public XMLDocument nextDocument() throws XMLDBCException;
  
}

