/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Odonata.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.xpath;

import java.util.ArrayList;

public class PathExprImpl /*extends ArrayList*/ implements PathExpr {

	private ArrayList steps = null;
	private String hashCodeString = null;
	/**
	 * Default constructor
	 *
	 */
	public PathExprImpl() {
		//super();
		steps = new ArrayList();
	}

	/**
	 * Other constructor
	 * @param size initial step size
	 */
	public PathExprImpl(int size) {
		//super(size);
		steps = new ArrayList(size);
	}

	/**
	 * Other constructor
	 * @param steps initial steps
	 */
	public PathExprImpl(ArrayList steps) {
//		super(steps.size());
//		addAll(steps);
		this.steps = (ArrayList)steps.clone();

	}

	/**
	 * 
	 * @param num index of the step to be returned
	 * @return the step with the given index if existing otherwise returns null
	 */
	public StepExpr getStep(int num) {
		if (num < 0 || num >= steps.size())
			return null;
		return (StepExpr) steps.get(num);
	}

	/**
	 * 
	 * @return the step with the given index if existing otherwise returns null
	 */
	public ArrayList getSteps() {
		return steps;
	}

	/**
	 * 
	 * @return the step with the given index if existing otherwise returns null
	 */
	public Object clone() throws CloneNotSupportedException {
		PathExprImpl newobj = new PathExprImpl(steps);
		return newobj;
	}

	/**
	 * 
	 */
	public String toHashCodeString() {
		if (hashCodeString != null)
			return hashCodeString;
		StringBuffer buf = new StringBuffer();
		for (int i = 0; i < steps.size(); i++) {
			buf.append(((StepExpr) steps.get(i)).toHashCodeString());
		}
		hashCodeString = buf.toString();
		return hashCodeString;
	}
	
//	public String toString() {
//		StringBuffer buf = new StringBuffer();
//		for (int i = 0; i < steps.size(); i++) {
//			buf.append(((StepExpr) steps.get(i)).toString());
//		}
//		return buf.toString();
//	}

	/**
	 * 
	 */
	public boolean equals(Object o) {
		if (!(o instanceof PathExprImpl))
			return false;
		return toHashCodeString().equals(((PathExprImpl)o).toHashCodeString());
	}

	// special stuff for hashmap
	public int hashCode() {
		String str = ((PathExprImpl)this).toHashCodeString();
		return str.hashCode();
	}

}
