/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.xpath.datamodel;

import org.xquark.schema.Declaration;
import org.xquark.schema.Type;
import org.xquark.xpath.datamodel.xerces.dom.DocumentImpl;
import org.xquark.xpath.datamodel.xerces.dom.TextImpl;

public class TypedValueImpl extends TextImpl implements TypedValue {
    private static final String RCSRevision = "$Revision: 1.2 $";
    private static final String RCSName = "$Name: XQ1_1_1 $";
    public Type type = null;
    public Object typedValue = null;

    //private String normalizedStringValue = null;
    public TypedValueImpl(DocumentImpl ownerDocument, String value) {
        super(ownerDocument, value);
    }

    public void setType(Type type) {
        this.type = type;
    }

    public void setTypedValue(Object typedValue) {
        this.typedValue = typedValue;
    }

    public void setDeclaration(Declaration declaration) {
    }

    public Type getType() {
        return type;
    }

    public Object getTypedValue() {
        return typedValue;
    }

    public Object getExtendedTypedValue() {
        return typedValue;
    }

    public Declaration getDeclaration() {
        return null;
    }

    public void setNormalizedStringValue(String normalizedStringValue) {
        this.setNodeValue(normalizedStringValue);
    }

    public String getNormalizedStringValue() {
        return this.getNodeValue();
    }
}
