/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.datastructure;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;

public class SortedKeyMap extends TreeMap {
	// **********************************************************************
	// * VERSIONING
	// **********************************************************************
	private static final String RCSRevision = "$Revision: 1.2 $";
	private static final String RCSName = "$Name: XQ1_1_1 $";

	private Tuple next = null;
	private ArrayList currentlist = null;
	private int currentindex = -1;
	private Iterator iterator = null;

	public void makeIterator() {
		iterator = this.entrySet().iterator();
		Map.Entry mapentry = (Map.Entry)iterator.next();
		currentlist = (ArrayList)mapentry.getValue();
		currentindex = 0;
		next = (Tuple) currentlist.get(currentindex);
	}
	
	public Tuple next() {
		if (next != null || hasNext()) {
			Tuple retval = next;
			next = null;
			return retval;
		}
		return null;
	}

	public boolean hasNext() {
		if (iterator == null)
			return false;
		if (next != null)
			return true;
		if (currentindex < currentlist.size() - 1) {
			currentindex++;
			next = (Tuple) currentlist.get(currentindex);
			return true;
		}
		if (!iterator.hasNext()) {
			currentlist = null;
			iterator = null;
			return false;
		}
		Map.Entry mapentry = (Map.Entry)iterator.next();
		currentlist = (ArrayList)mapentry.getValue();
		currentindex = 0;
		next = (Tuple) currentlist.get(currentindex);
		return true;			
	}
}
