/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.datastructure;

import java.util.ArrayList;

import org.xquark.xquery.parser.util.Constants;

public class TupleKey extends ArrayList implements Comparable {
	// **********************************************************************
	// * VERSIONING
	// **********************************************************************
	private static final String RCSRevision = "$Revision: 1.2 $";
	private static final String RCSName = "$Name: XQ1_1_1 $";

	private int order = Constants.ASCENDING_ORDER;

	TupleKey(int size, int order) {
		super(size);
		this.order = order;
	}

	public int compareTo(Object obj) {
		int retVal = 0;
		int i = 0;
		while (i < size() && retVal == 0) {
			if (get(i) == null) {
				if (((TupleKey) obj).get(i) == null)
					retVal = 0;
				else
					retVal = 1;
			} else
				retVal = DOMUtils.compareObjects((Comparable)get(i),(Comparable)((TupleKey) obj).get(i));
			i++;
		}
		if (i == size() && order == Constants.DESCENDING_ORDER)
			retVal = -retVal;
		return retVal;
	}

}
