/*
 * This file belongs to the XQuare distribution. Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307. You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.xquery.metadata;

import java.util.ArrayList;
import java.util.HashMap;

import org.xquark.util.NamespaceContextStack;
import org.xquark.xquery.parser.FunctionDeclaration;
import org.xquark.xquery.parser.Variable;

// ***************************************************************************
// * Class 'MetaCollection'
// ***************************************************************************

public class MetaModule {
    // **********************************************************************
    // * Constant
    // **********************************************************************
    private static final String RCSRevision = "$Revision: 1.2 $";

    private static final String RCSName = "$Name: XQ1_1_1 $";

    protected ArrayList declList = null;
    
    protected HashMap hashVarList = null;

    protected HashMap hashFuncList = null;

    protected String namespace = null;

    protected NamespaceContextStack declarations = null;
    
    // variables
    public HashMap getVariables() {
        return hashVarList;
    }

    public Variable getVariableDefinition(String name) {
        if (name == null || hashVarList == null)
            return null;
        return (Variable) hashVarList.get(name);
    }

    // functions
    public HashMap getFunctions() {
        return hashFuncList;
    }

    public FunctionDeclaration getFunctionDefinition(String name) {
        if (name == null || hashFuncList == null)
            return null;
        return (FunctionDeclaration) hashFuncList.get(name);
    }

    // namespace
    public String getNamespace() {
        return namespace;
    }

    public void setNamespace(String location) {
        this.namespace = location;
    }

	public void setDeclList(ArrayList declList) {
		this.declList = declList;
	}
	public ArrayList getDeclList() {
		return declList;
	}

	// declarations
	public NamespaceContextStack getDeclarations() {
		return declarations;
	}
	public void setDeclarations(NamespaceContextStack declarations) {
		this.declarations = declarations;
	}

    // **********************************************************************
    // * Destructor
    // **********************************************************************

    /**
     * Dereference allocated object which will be further be destroy by the garbage collector.
     */
    protected void finalize() throws Throwable {
    }
}