/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

/*
[127]    ItemType    ::=    AtomicType | KindTest | ("item" "(" ")") 
[126]    AtomicType    ::=    QName 
*/

package org.xquark.xquery.parser;

import org.xquark.xquery.typing.TypeException;


public class ItemType extends XQueryExpression implements Cloneable {
	
	private static final String RCSRevision = "$Revision: 1.9 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";
	
	protected XQueryExpression expression = null;
	
	// #############################################################################
	// VISITOR STUFF
	// #############################################################################
	
	public void accept(ParserVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}
	
	// #############################################################################
	// CONSTRUCTOR STUFF
	// #############################################################################
	
	public ItemType(XQueryExpression expression, XQueryModule parentModule) throws TypeException, XQueryException {
		setExpression(expression);
		setParentModule(parentModule);
		if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
			accept(parentModule.getStaticContext().getTypeVisitor());
	}
	
	// #############################################################################
	// ATTRIBUTE ACCESS STUFF
	// #############################################################################
	    
	public XQueryExpression getExpression() { return expression; }
	public void setExpression(XQueryExpression expression) throws XQueryException {
		this.expression = expression;
		if (expression != null) {
			this.expression.setParentModule(parentModule);
			this.expression.setParentExpression(this);
		}
	}
	
}
