/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2004 Odonata.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.xquery.parser;

import java.util.ArrayList;

import org.xquark.xquery.typing.TypeException;

public class ParenthesizedExpression extends XQueryUnaryOperatorExpression {

	// #############################################################################
	// VISITOR STUFF
	// #############################################################################

	public void accept(ParserVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}

    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    
    public ParenthesizedExpression(XQueryExpression expression, XQueryModule parentModule) throws TypeException, XQueryException {
        super(expression);
        setParentModule(parentModule);
		if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
			accept(parentModule.getStaticContext().getTypeVisitor());
    }

    // method redifinition
	public void setRoot(boolean root) {
	    if (expression != null)
	        expression.setRoot(root);
	}
	
	public ArrayList getDependIDs() {
		if (expression != null)
		    return expression.getDependIDs();
		return null;
	}
	public void setDependIDs(ArrayList dependIDs) {
		if (expression != null)
		    expression.setDependIDs(dependIDs);
	}

}
