/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

/*
[125]    SequenceType    ::=    (ItemType OccurrenceIndicator?) | ("empty" "(" ")") 
[144]    OccurrenceIndicator    ::=    "?" | "*" | "+" 
*/

package org.xquark.xquery.parser;

import org.xquark.xquery.typing.TypeException;

public class SequenceType extends XQueryExpression implements Cloneable {
	
	private static final String RCSRevision = "$Revision: 1.7 $";
	private static final String RCSName     = "$Name: XQ1_1_1 $";
	
	protected ItemType itemType = null;
	protected int occurrence = -1;
	
	// #############################################################################
	// VISITOR STUFF
	// #############################################################################
	
	public void accept(ParserVisitor visitor) throws XQueryException {
		visitor.visit(this);
	}
	
	// #############################################################################
	// CONSTRUCTOR STUFF
	// #############################################################################
	
	public SequenceType(ItemType itemType, int occurrence, XQueryModule parentModule) throws TypeException, XQueryException {
		setItemType(itemType);
		setOccurrence(occurrence);
		setParentModule(parentModule);
		if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
			accept(parentModule.getStaticContext().getTypeVisitor());
	}
	
	// #############################################################################
	// ATTRIBUTE ACCESS STUFF
	// #############################################################################
			
	public void setItemType(ItemType itemType) { this.itemType = itemType; }
	
	public ItemType getItemType() { return itemType; }
	
	public void setOccurrence(int occurrence) { this.occurrence = occurrence; }
	
	public int getOccurrence() { return occurrence; }
			
}
