/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Universite de Versailles Saint-Quentin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */


package org.xquark.xquery.parser.primitivefunctions.xsfunctions;

import java.util.ArrayList;

import org.xquark.xquery.parser.*;
import org.xquark.xquery.typing.TypeException;

public class FunctionFLOAT extends PrimitiveFunctionCall {
    private static final String RCSRevision = "$Revision: 1.7 $";
    private static final String RCSName     = "$Name: XQ1_1_1 $";
    
    // #############################################################################
    // VISITOR STUFF
    // #############################################################################
    
    public void accept(ParserVisitor visitor) throws XQueryException {
        visitor.visit(this);
    }
    
    // #############################################################################
    // CONSTRUCTOR STUFF
    // #############################################################################
    
    public FunctionFLOAT(ArrayList args, XQueryModule parentModule) throws TypeException, XQueryException {
        super(new QName("float",null),args);
		if (args.get(0) instanceof ValueString)
        	args.set(0, convert((ValueString)args.get(0),parentModule));
		else if (parentModule != null && parentModule.getStaticContext().getTypeVisitor() != null)
			accept(parentModule.getStaticContext().getTypeVisitor());
		setParentModule(parentModule);
        setArguments(args);
    }
    
    // this function should be called with one argument
    public void setArguments(ArrayList arguments) throws XQueryException {
        if (arguments == null || arguments.size() != 1) throw new XQueryException("Function float should have one argument");
        super.setArguments(arguments);
    }
    
    private ValueFloat convert(ValueString valString,XQueryModule parentModule)  throws XQueryException {
        String val =   valString.getStringValue();
        ValueFloat  valInt = new ValueFloat(val,parentModule);
        return valInt;
    }
        
}

