/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Odonata.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.xquery.typing;

import java.util.ArrayList;
import java.util.List;

public class PrimeList extends ArrayList {

	public PrimeList() {
		super();
	}
	
	public void add(QType qtype) {
		if (qtype == null) 
			return;
		List list = qtype.getList();
		if (list != null) {
			addAll(list);
			return;
		}
		byte occ = qtype.getOccurence();
		boolean toBeAdded = true;
		for (int i=0;i<size();i++) {
			QType qtypei = (QType) get(i);
			if (!qtypei.equals(qtype))
				continue;
			byte occi = qtypei.getOccurence();
			if (occi == QType.OCC_0_N || occi == occ || occ == QType.OCC_1_1)
				return;
			if (occ == QType.OCC_0_N || occi == QType.OCC_1_1) {
				set(i,qtype);
				return;
			}
			set(i,qtype.changeOccurence(QType.OCC_0_N));
			return;
		}
		if (toBeAdded)
			add((Object)qtype);
	}
	
	public void addAll(List list) {
		if (list == null || list.isEmpty())
			return;
		for (int i=0;i<list.size();i++) {
			add((QType)list.get(i));
		}
	}

}
