/*
 * This file belongs to the XQuare distribution.
 * Copyright (C) 2003 Odonata.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307.
 * You can also get it at http://www.gnu.org/licenses/lgpl.html
 * 
 * For more information on this software, see http://www.xquare.org.
 */

package org.xquark.xquery.xdbc;

import java.util.List;
import java.util.Set;

import org.xquark.xml.xdbc.*;


public class XMLDataSourceMetaDataConnectionWrapper implements XMLDataSourceMetaData {

	private XMLDataSourceMetaData metadata;
	private XMLConnection connection;
	
	public XMLDataSourceMetaDataConnectionWrapper(XMLConnection connection, XMLDataSourceMetaData metadata) {
		this.metadata = metadata;
		this.connection = connection;
	}
	
	public XMLConnection getConnection() {
		return connection;
	}
	
    /**
     * @return
     */
    public Set getCapabilities() {
        return metadata.getCapabilities();
    }

//    /**
//     * @return
//     * @throws XMLDBCException
//     * @throws XMLDBCNotSupportedException
//     */
    public List getCollectionNames() throws XMLDBCException, XMLDBCNotSupportedException {
        return metadata.getCollectionNames();
    }

    public List getMetaModules() throws XMLDBCException {
        return metadata.getMetaModules();
    }
    /**
     * @return
     * @throws XMLDBCException
     */
    public XMLDocument getMetaData() throws XMLDBCException {
        return metadata.getMetaData();
    }

//    /**
//     * @param colName
//     * @return
//     * @throws XMLDBCException
//     */
    public XMLDocument getPathSet(String colName) throws XMLDBCException {
        return metadata.getPathSet(colName);
    }

    /**
     * @param propertyId
     * @return
     * @throws XMLDBCNotRecognizedException
     */
    public Object getProperty(String propertyId) throws XMLDBCNotRecognizedException {
        return metadata.getProperty(propertyId);
    }

    /**
     * @return
     */
    public String[] getPropertyList() {
        return metadata.getPropertyList();
    }

    /**
     * @param targetNamespace
     * @return
     * @throws XMLDBCException
     */
    public XMLDocument getSchema(String targetNamespace) throws XMLDBCException {
        return metadata.getSchema(targetNamespace);
    }

    /**
     * @return
     * @throws XMLDBCException
     */
    public List getSchemaNamespaces() throws XMLDBCException {
        return metadata.getSchemaNamespaces();
    }

}
